<?php
// توکن ربات تلگرام
$bot_token = "8101264345:AAH-HpUfLF2GIdNbRCIQ1EMRTniMnFM6R-E";
$api_url = "https://api.telegram.org/bot$bot_token/";

// مسیر فایل داده‌ها برای ذخیره اطلاعات مشتریان
define('CUSTOMER_FILE', __DIR__ . '/customers.json');
define('DEBT_FILE', __DIR__ . '/debts.json');

// دریافت اطلاعات به‌صورت JSON از وبهوک
$update = json_decode(file_get_contents('php://input'), true);

$chat_id = $update['message']['chat']['id'] ?? null;
$message_text = $update['message']['text'] ?? null;

// متد ارسال پیام
function sendMessage($chat_id, $text, $reply_markup = null)
{
    global $api_url;
    $data = [
        'chat_id' => $chat_id,
        'text' => $text,
        'reply_markup' => json_encode($reply_markup)
    ];
    file_get_contents($api_url . "sendMessage?" . http_build_query($data));
}

// نمایش منوی اصلی
function showMainMenu($chat_id)
{
    $keyboard = [
        [['text' => 'ثبت مشتری'], ['text' => 'حذف مشتری']],
        [['text' => 'ثبت بدهی'], ['text' => 'حذف بدهی']]
    ];
    sendMessage($chat_id, "لطفاً گزینه مورد نظر را انتخاب کنید:", ['keyboard' => $keyboard, 'resize_keyboard' => true]);
}

// بررسی و نمایش منوی اصلی
if ($message_text == "/start") {
    showMainMenu($chat_id);
}
// مدیریت دکمه ثبت مشتری
if ($message_text == "ثبت مشتری") {
    sendMessage($chat_id, "لطفاً نام مشتری را وارد کنید:", ['keyboard' => [[['text' => 'انصراف']]], 'resize_keyboard' => true]);
    file_put_contents("state_$chat_id.txt", "waiting_for_customer_name");
    exit;
}

// مدیریت دریافت نام مشتری
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_customer_name") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    // ذخیره نام مشتری
    $customers = file_exists(CUSTOMER_FILE) ? json_decode(file_get_contents(CUSTOMER_FILE), true) : [];
    $customers[] = $message_text;
    file_put_contents(CUSTOMER_FILE, json_encode($customers));
    
    sendMessage($chat_id, "مشتری با نام '{$message_text}' ثبت شد.", null);
    unlink("state_$chat_id.txt");
    showMainMenu($chat_id);
    exit;
}

// مدیریت دکمه حذف مشتری
if ($message_text == "حذف مشتری") {
    $customers = file_exists(CUSTOMER_FILE) ? json_decode(file_get_contents(CUSTOMER_FILE), true) : [];
    
    if (empty($customers)) {
        sendMessage($chat_id, "هیچ مشتری ثبت نشده است.", null);
        showMainMenu($chat_id);
        exit;
    }

    $keyboard = [['text' => 'انصراف']];
    foreach ($customers as $customer) {
        $keyboard[] = [['text' => $customer]];
    }
    sendMessage($chat_id, "مشتری مورد نظر را برای حذف انتخاب کنید:", ['keyboard' => $keyboard, 'resize_keyboard' => true]);
    file_put_contents("state_$chat_id.txt", "waiting_for_customer_deletion");
}
// مدیریت حذف مشتری
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_customer_deletion") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    $customers = json_decode(file_get_contents(CUSTOMER_FILE), true);

    if (($key = array_search($message_text, $customers)) !== false) {
        unset($customers[$key]);
        file_put_contents(CUSTOMER_FILE, json_encode(array_values($customers)));
        sendMessage($chat_id, "مشتری '{$message_text}' با موفقیت حذف شد.", null);
    } else {
        sendMessage($chat_id, "مشتری یافت نشد.", null);
    }

    unlink("state_$chat_id.txt");
    showMainMenu($chat_id);
    exit;
}

// مدیریت دکمه ثبت بدهی
if ($message_text == "ثبت بدهی") {
    $customers = file_exists(CUSTOMER_FILE) ? json_decode(file_get_contents(CUSTOMER_FILE), true) : [];
    
    if (empty($customers)) {
        sendMessage($chat_id, "هیچ مشتری ثبت نشده است.", null);
        showMainMenu($chat_id);
        exit;
    }

    $keyboard = [['text' => 'انصراف']];
    foreach ($customers as $customer) {
        $keyboard[] = [['text' => $customer]];
    }
    sendMessage($chat_id, "مشتری مورد نظر را برای ثبت بدهی انتخاب کنید:", ['keyboard' => $keyboard, 'resize_keyboard' => true]);
    file_put_contents("state_$chat_id.txt", "waiting_for_debt_customer");
}

// مدیریت انتخاب مشتری برای ثبت بدهی
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_debt_customer") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    $customers = json_decode(file_get_contents(CUSTOMER_FILE), true);
    if (in_array($message_text, $customers)) {
        file_put_contents("selected_customer_$chat_id.txt", $message_text);
        sendMessage($chat_id, "لطفاً مبلغ بدهی را وارد کنید:", null);
        file_put_contents("state_$chat_id.txt", "waiting_for_debt_amount");
    } else {
        sendMessage($chat_id, "مشتری یافت نشد.", null);
    }
}
// مدیریت دریافت مبلغ بدهی
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_debt_amount") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        unlink("selected_customer_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    $customer = file_get_contents("selected_customer_$chat_id.txt");
    $debts = file_exists(DEBT_FILE) ? json_decode(file_get_contents(DEBT_FILE), true) : [];

    if (!isset($debts[$customer])) {
        $debts[$customer] = [];
    }

    $debts[$customer][] = $message_text;
    file_put_contents(DEBT_FILE, json_encode($debts));
    sendMessage($chat_id, "بدهی به مبلغ '{$message_text}' برای مشتری '{$customer}' ثبت شد.", null);

    unlink("state_$chat_id.txt");
    unlink("selected_customer_$chat_id.txt");
    showMainMenu($chat_id);
    exit;
}

// مدیریت دکمه حذف بدهی
if ($message_text == "حذف بدهی") {
    $customers = file_exists(DEBT_FILE) ? json_decode(file_get_contents(DEBT_FILE), true) : [];

    if (empty($customers)) {
        sendMessage($chat_id, "هیچ بدهی ثبت نشده است.", null);
        showMainMenu($chat_id);
        exit;
    }

    $keyboard = [['text' => 'انصراف']];
    foreach (array_keys($customers) as $customer) {
        $keyboard[] = [['text' => $customer]];
    }
    sendMessage($chat_id, "مشتری مورد نظر را برای حذف بدهی انتخاب کنید:", ['keyboard' => $keyboard, 'resize_keyboard' => true]);
    file_put_contents("state_$chat_id.txt", "waiting_for_debt_removal_customer");
}

// مدیریت انتخاب مشتری برای حذف بدهی
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_debt_removal_customer") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    $debts = json_decode(file_get_contents(DEBT_FILE), true);
    if (isset($debts[$message_text])) {
        file_put_contents("selected_customer_$chat_id.txt", $message_text);
        
        $debt_list = "لیست بدهی‌های مشتری '{$message_text}':\n";
        foreach ($debts[$message_text] as $index => $debt) {
            $debt_list .= ($index + 1) . ". مبلغ: " . $debt . " تومان\n";
        }
        $debt_list .= "\nلطفاً شماره بدهی مورد نظر را وارد کنید:";
        sendMessage($chat_id, $debt_list, null);
        
        file_put_contents("state_$chat_id.txt", "waiting_for_debt_removal_number");
    } else {
        sendMessage($chat_id, "مشتری یافت نشد یا بدهی ندارد.", null);
    }
}
// مدیریت دریافت شماره بدهی برای حذف
if (file_exists("state_$chat_id.txt") && file_get_contents("state_$chat_id.txt") == "waiting_for_debt_removal_number") {
    if ($message_text == "انصراف") {
        unlink("state_$chat_id.txt");
        unlink("selected_customer_$chat_id.txt");
        showMainMenu($chat_id);
        exit;
    }

    $customer = file_get_contents("selected_customer_$chat_id.txt");
    $debts = json_decode(file_get_contents(DEBT_FILE), true);

    if (!isset($debts[$customer]) || !is_numeric($message_text) || $message_text < 1 || $message_text > count($debts[$customer])) {
        sendMessage($chat_id, "شماره بدهی معتبر نیست. لطفاً دوباره تلاش کنید.", null);
        exit;
    }

    // حذف بدهی
    $index = $message_text - 1;
    $removed_debt = $debts[$customer][$index];
    unset($debts[$customer][$index]);
    $debts[$customer] = array_values($debts[$customer]);

    if (empty($debts[$customer])) {
        unset($debts[$customer]);
    }

    file_put_contents(DEBT_FILE, json_encode($debts));
    sendMessage($chat_id, "بدهی به مبلغ '{$removed_debt}' تومان برای مشتری '{$customer}' حذف شد.", null);

    unlink("state_$chat_id.txt");
    unlink("selected_customer_$chat_id.txt");
    showMainMenu($chat_id);
    exit;
}

// مدیریت دکمه انصراف در تمامی مراحل
if ($message_text == "انصراف") {
    unlink("state_$chat_id.txt");
    unlink("selected_customer_$chat_id.txt");
    showMainMenu($chat_id);
    exit;
}
?>




