<?php




$lockFile = __DIR__ . "/send_file.lock";

// اگر فایل قفل موجود باشد و زمان آن کمتر از 2 دقیقه نباشد، اجرای جدید را متوقف کن
if (file_exists($lockFile) && (time() - filemtime($lockFile)) < 120) {
    echo "Script is already running.\n";
    exit;
}

// ایجاد یا به‌روزرسانی فایل قفل
file_put_contents($lockFile, "running");

// در پایان اسکریپت، قفل را پاک کن
register_shutdown_function(function() use ($lockFile) {
    if (file_exists($lockFile)) {
        unlink($lockFile);
    }
});












$botToken = "7928431608:AAH7DP4X-DUvA_ZaMKEuV-WYLPDVt_ChP_o";
$apiURL = "https://api.telegram.org/bot$botToken/";

// مسیر فایل chat_id.txt
$chatIdFile = __DIR__ . "/chat_id.txt";

// خواندن چت آیدی‌ها از فایل
if (file_exists($chatIdFile)) {
    $chatIds = file($chatIdFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES); // هر خط یک چت آیدی
} else {
    echo "File chat_id.txt does not exist.\n";
    exit; // پایان اسکریپت اگر فایل موجود نباشد
}

// تابع برای ارسال فایل
function sendFile($chatId, $dataFile, $apiURL) {
    if (file_exists($dataFile)) {
        $postData = [
            'chat_id' => $chatId,
            'document' => new CURLFile(realpath($dataFile))
        ];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $apiURL . "sendDocument");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);

        // نمایش نتیجه (اختیاری)
        if ($response) {
            echo "File sent successfully to chat ID: $chatId\n";
        } else {
            echo "Error in sending file to chat ID: $chatId\n";
        }
    } else {
        echo "File does not exist for chat ID: $chatId ($dataFile)\n";
    }
}

// ارسال فایل برای هر چت آیدی
foreach ($chatIds as $chatId) {
    $dataFile = __DIR__ . "/customer_data_$chatId.json"; // مسیر فایل برای هر چت آیدی
    echo "Checking file for chat ID: $chatId\n"; // نمایش پیام بررسی فایل (اختیاری)
    
    // ارسال فایل
    sendFile($chatId, $dataFile, $apiURL);

    // ارسال پیام "♻️ فایل پشتیبان آخر شب ♻️" بعد از ارسال فایل
    $message = "♻️ فایل پشتیبان آخر شب ♻️";
    sendMessage($chatId, $message, $apiURL);
}

// تابع ارسال پیام به تلگرام
function sendMessage($chatId, $message, $apiURL) {
    $postData = [
        'chat_id' => $chatId,
        'text' => $message
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $apiURL . "sendMessage");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);

    // نمایش نتیجه ارسال پیام (اختیاری)
    if ($response) {
        echo "Message sent successfully to chat ID: $chatId\n";
    } else {
        echo "Error in sending message to chat ID: $chatId\n";
    }
}
?>
